package net.mc_pandacraft.java.plugin.pandacraftutils;


import net.mc_pandacraft.java.plugin.pandacraftutils.afk.CommandAfk;
import net.mc_pandacraft.java.plugin.pandacraftutils.chat_analyzer.ChatAnalysisManager;
import net.mc_pandacraft.java.plugin.pandacraftutils.creativ_cheat.CreativCheatManager;
import net.mc_pandacraft.java.plugin.pandacraftutils.list.CommandList;
import net.mc_pandacraft.java.plugin.pandacraftutils.me.CommandMe;
import net.mc_pandacraft.java.plugin.pandacraftutils.nopvp_protect.NoPvpProtectManager;
import net.mc_pandacraft.java.plugin.pandacraftutils.ping.CommandPing;
import net.mc_pandacraft.java.plugin.pandacraftutils.player_count_list.PacketOutServerInfoListener;
import net.mc_pandacraft.java.plugin.pandacraftutils.setblock.CommandSetblock;
import net.mc_pandacraft.java.plugin.pandacraftutils.spawntime.SpawnTimeManager;
import net.mc_pandacraft.java.plugin.pandacraftutils.speed_message.CommandSpeedMessage;
import net.mc_pandacraft.java.plugin.pandacraftutils.survival_cuboid.CommandWandSelection;
import net.mc_pandacraft.java.plugin.pandacraftutils.system.CommandSystem;

import org.bukkit.plugin.java.JavaPlugin;

public class PandacraftUtils extends JavaPlugin {
	
	public CommandAfk commandAfk;
	public CommandList commandPlayers;
	public CommandSetblock commandSetblock;
	public CommandSystem commandSystem;
	public CommandPing commandPing;
	public CommandMe commandMe;
	public CommandSpeedMessage commandSpeedMessage;
	public CommandWandSelection commandWandSelection;
	
	
	public SpawnTimeManager spawnTimeManager;
	public ChatAnalysisManager chatAnalysisManager;
	public CreativCheatManager creativCheatManager;
	public NoPvpProtectManager noPvpProtectManager;
	
	public PacketOutServerInfoListener serverPingListener;

	
	@Override
    public void onEnable(){
		
		// initialisation de la configuration
		new ConfigManager(null, this);
		
		commandPlayers = new CommandList(this);
        commandSetblock = new CommandSetblock(this);
		commandAfk = new CommandAfk(this);
		commandSystem = new CommandSystem(this);
		commandPing = new CommandPing(this);
		commandMe = new CommandMe(this);
		commandSpeedMessage = new CommandSpeedMessage(this);	// messages rapides
		commandWandSelection = new CommandWandSelection(this);

		spawnTimeManager = new SpawnTimeManager(this);
		chatAnalysisManager = new ChatAnalysisManager(this);
		creativCheatManager = new CreativCheatManager(this);
		noPvpProtectManager = new NoPvpProtectManager(this);
		
		serverPingListener = new PacketOutServerInfoListener(this);
    }
	
	
	@Override
	public void onDisable(){
		commandPlayers = null;
        commandSetblock = null;
        commandAfk = null;
        commandSystem = null;
        commandPing = null;
        commandMe = null;
        commandSpeedMessage = null;
        
        spawnTimeManager = null;
        chatAnalysisManager = null;
        creativCheatManager = null;
        noPvpProtectManager = null;
        
        serverPingListener = null;
    }

}

